/**************************************************** 2005.11.23 ************/
// vibfunc.h   UV~[^̂߂̊֐Q                             //
//    FourierS,T(), InvFourierS,T()             ----05.11.14 C----       //
//    Gaussian(), readrandom()                  ----05.11.18ǉ-----       //
//    disrkg()                                  ----05.11.23ǉ-----       //
//  (1-1)rkg(t,dt,z0,z4,n) : Runge-Kutta-Gill@ɂ̉         //
//  (1-2)disrkg(t,dt,z0,z4,n,cnt) : UI͂ɑ΂Runge-Kutta-Gill@    //
//  (2-1)det=determ(n, *a, nmax)        Fs񎮂̒l                        //
//  (2-2)det=imatrx(n, *a, nmax)         : tsƍs񎮂̒l               //
//  (3-1)FourierS(y[], n, m, Fc[], Fs[]) : FourierWJ                  //
//  (3-2)FourierT(y[], dt, n, m, Fc[], Fs[]) : Fourierϊ                  //
//  (4-1)InvFourierS(y[], n, m, Fc[], Fs[]) : Fourier̘a               //
//  (4-2)InvFourierT(y[], dom, m, n, Fc[], Fs[]) : Fouriertϊ            //
//  (6)  drawfigure(r0[], n, a[]) : n̃}X̐ȔuԐ}                 //
//  (7)  drawcurve1(r0[], wx, wy, m, a[] color[])                           //
//               : 莞ԊԊu1{̐UȐ`                          //
//  (8)  drawcurven(r0[], wx, wy[], n, m, *a, mmax)                         //
//               : 莞ԊԊun{̐UȐ`                          //
//  (9)  drawcurve0(r0[], wx, wy, m, *a, mmax)   : (X,Y)ʏ̔CӋȐ`//
//  (10) drawbargraph(r0[], wx, wy, m, a[]) : _Ot`                  //
//  (11) drawfreqcurve()  : UԊuŎg`                //
//  (12-1) UniformtoGauss(yy) : lzf[^琳Kzf[^֕ϊ      //
//  (12-2) Gaussian() : ilzj琳Kzf[^              //
//  (12-3) readrandom() : lzƐKz̑Ή\t@Cǂݍ  //
//@[]@Ή\̃t@C𓯂[NXy[XɓĂ                //
/****************************************************************************/

#include	<stdio.h>
#include	<conio.h>
#include	<math.h>
#include	<malloc.h>
#include    <gl/glut.h>
//#include    "graph2d.h"

float  ncolor[21][4] = {1.0,0.0,0.0,0.0,  0.0,1.0,0.0,0.0, 0.0,0.0,1.0,0.0,
                        1.0,0.2,0.0,0.0,  0.0,1.0,0.2,0.0, 0.2,0.0,1.0,0.0,
                        1.0,0.4,0.0,0.0,  0.0,1.0,0.4,0.0, 0.4,0.0,1.0,0.0,
                        1.0,0.6,0.0,0.0,  0.0,1.0,0.6,0.0, 0.6,0.0,1.0,0.0,
                        1.0,0.8,0.0,0.0,  0.0,1.0,0.8,0.0, 0.8,0.0,1.0,0.0,
                        1.0,1.0,0.0,0.0,  0.0,1.0,1.0,0.0, 1.0,0.0,1.0,0.0,
                        1.0,1.0,0.2,0.0,  0.2,1.0,1.0,0.0, 1.0,0.2,1.0,0.0};
double  xedge=0.99;

/**(1-1)***************************************************************/
// rkg(t,dt,z0,z4,n) : Runge-Kutta-Gill@ɂ̉         //
//         equation : z[]/dt = f(t,z[])                               //
//         t,dt : time, incremental time                              //
//        z0,z4 : initial state(t=t), final state(t=t+dt)             //
//        n : n equations (<20)                                       //
//        define equation f(i,t,y) : i-th equation (i=0; i<n)         //
/**********************************************************************/
double f();

void rkg1(double t,double dt,double *z0, double *z4, int n)
{
   static double a1=0.292893219, a2=1.70710678, a3=0.16666667;
   static double k0, k1, k2, k3, r1, r2, r3, r4;
   static double *z1, *z2, *z3;
   static double *q1, *q2, *q3, *q4;
   static int    i;

	if (((z1 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((z2 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((z3 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q1 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q2 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q3 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q4 = (double *)calloc(n, sizeof(double))) == NULL))
	{
		printf("memory overflow\n");
		exit(1);
	}

   for(i=0;i<n;i++)
   {
	 k0 = dt*f(i,t, z0);          r1 = 0.5*k0;
     *(z1+i) = *(z0+i) + r1;      *(q1+i)=3.0*r1 - 0.5*k0;
   }
   for(i=0;i<n;i++)
   { k1 = dt * f(i,t+0.5*dt, z1); r2 = a1*(k1 - *(q1+i));
     *(z2+i) = *(z1+i) + r2;      *(q2+i) = *(q1+i) + 3.0*r2 - a1*k1;
   }
   for(i=0;i<n;i++)
   { k2 = dt*f(i,t+0.5*dt, z2);   r3 = a2*(k2 - *(q2+i));
     *(z3+i) = *(z2+i) + r3;      *(q3+i)= *(q2+i) + 3.0*r3 - a2*k2;
   }
   for(i=0;i<n;i++)
   { k3 = dt*f(i,t+dt, z3);       r4 = a3*(k3 - 2.0* *(q3+i));
     *(z4+i) = *(z3+i) + r4;      *(q4+i) = *(q3+i) + 3.0*r4 - 0.5*k3;
   }
	free( z1 );	free( z2 );	free( z3 );
	free( q1 );	free( q2 );	free( q3 );	free( q4 );
}
/***(1-1) rkg() end *************************************************/

/****(1-2)*************************************************************/
// disrkg(t,dt,z0,z4,n,cnt) : Runge-Kutta-Gill@ɂ̉  //
//         equation : z[]/dt = f(t,z[],cnt)                           //
//         t,dt : time, incremental time                              //
//        z0[],z4[] : initial state(t=t), final state(t=t+dt)         //
//        n : n equations                                             //
//        cnt : External force remains constant, while in one rkg()   //
//              procedure (cnt=0:renewal, cnt!=0 remain constant      // 
//        define equation f(i,t,y) : i-th equation (i=0; i<n)         //
/**********************************************************************/
void disrkg(double t,double dt,double *z0, double *z4, int n, int cnt)
{
   static double a1=0.292893219, a2=1.70710678, a3=0.16666667;
   static double k0, k1, k2, k3, r1, r2, r3, r4;
   static double *z1, *z2, *z3;
   static double *q1, *q2, *q3, *q4;
   static int    i;

	if (((z1 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((z2 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((z3 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q1 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q2 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q3 = (double *)calloc(n, sizeof(double))) == NULL)
	  ||((q4 = (double *)calloc(n, sizeof(double))) == NULL))
	{
		printf("memory overflow\n");
		exit(1);
	}

   for(i=0;i<n;i++)
   {
	 k0 = dt*f(i,t, z0, cnt);       r1 = 0.5*k0;
     *(z1+i) = *(z0+i) + r1;      *(q1+i)=3.0*r1 - 0.5*k0;
   }
   for(i=0;i<n;i++)
   { k1 = dt * f(i,t+0.5*dt,z1,1); r2 = a1*(k1 - *(q1+i));
     *(z2+i) = *(z1+i) + r2;       *(q2+i) = *(q1+i) + 3.0*r2 - a1*k1;
   }
   for(i=0;i<n;i++)
   { k2 = dt*f(i,t+0.5*dt,z2,2);   r3 = a2*(k2 - *(q2+i));
     *(z3+i) = *(z2+i) + r3;      *(q3+i)= *(q2+i) + 3.0*r3 - a2*k2;
   }
   for(i=0;i<n;i++)
   { k3 = dt*f(i,t+dt,z3,3);       r4 = a3*(k3 - 2.0* *(q3+i));
     *(z4+i) = *(z3+i) + r4;      *(q4+i) = *(q3+i) + 3.0*r4 - 0.5*k3;
   }
	free( z1 );	free( z2 );	free( z3 );
	free( q1 );	free( q2 );	free( q3 );	free( q4 );
}
/******** (1-2) disrkg() end *****************************************/

#define   NRKG   20
void rkg(double t,double dt,double z0[], double z4[], int n)
{
   double a1=0.292893219, a2=1.70710678, a3=0.16666667;
   double z1[NRKG],z2[NRKG],z3[NRKG];
   double k0[NRKG],k1[NRKG],k2[NRKG],k3[NRKG];
   double r1[NRKG],r2[NRKG],r3[NRKG],r4[NRKG];
   double q1[NRKG],q2[NRKG],q3[NRKG],q4[NRKG];
   int    i;

   for(i=0;i<n;i++)
      {
	   k0[i]=dt*f(i,t,z0);        r1[i]=0.5*k0[i];
       z1[i]=z0[i]+r1[i];         q1[i]=3*r1[i]-0.5*k0[i];
      }
   for(i=0;i<n;i++)
      {k1[i]=dt*f(i,t+0.5*dt,z1); r2[i]=a1*(k1[i]-q1[i]);
       z2[i]=z1[i]+r2[i];         q2[i]=q1[i]+3*r2[i]-a1*k1[i];
      }
   for(i=0;i<n;i++)
      {k2[i]=dt*f(i,t+0.5*dt,z2); r3[i]=a2*(k2[i]-q2[i]);
       z3[i]=z2[i]+r3[i];         q3[i]=q2[i]+3*r3[i]-a2*k2[i];
     }
   for(i=0;i<n;i++)
      {k3[i]=dt*f(i,t+dt,z3);     r4[i]=a3*(k3[i]-2*q3[i]);
       z4[i]=z3[i]+r4[i];         q4[i]=q3[i]+3*r4[i]-0.5*k3[i];
      }
 }
/*******(1) rkg() end ***************************************************/

/**(2-1)*****************************************************************/
// det = determ(n, *a, nmax)                                            //
//  	 n:dimension, *a:double array nmax:a[nmax][nmax]                //
/************************************************************************/
double	determ(int n, double *a, int nmax)
{
 int	    i, j, k, mi, mk, *ipv, *w, *v;
 double 	*lu, s, t, det;

	if (((lu = (double *)calloc(n * n, sizeof(double))) == NULL)
	  ||((ipv = (int *)calloc(n, sizeof(int))) == NULL)
	  ||((w = (int *)calloc(n, sizeof(int))) == NULL)
	  ||((v = (int *)calloc(n, sizeof(int))) == NULL)) {
		printf("memory overflow\n");
		exit(1);
	}
	/* LU decomposition */
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			*(lu+n*i+j) = *(a+nmax*i+j);
	for (k = 0; k < n; k++)
		ipv[k] = k;
	for (k = 0; k < n; k++) {
		i = k;
		s = fabs(*(lu+n*ipv[k]+k));
		for (j = k + 1; j < n; j++) {
			t = fabs(*(lu+n*ipv[j]+k));
			if (t > s) { i = j; s = t; }
		}
		j = ipv[k]; ipv[k] = ipv[i]; ipv[i] = j;
		mk = ipv[k];
		s = *(lu+n*mk+k);
		for (i = k + 1; i < n; i++) {
			mi = ipv[i];
			t = *(lu+n*mi+k) / s;
			*(lu+n*mi+k) = t;
			for (j = k + 1; j < n; j++)
				*(lu+n*mi+j) -= t * *(lu+n*mk+j);
		}
	}
	/* determinant */
	for (i = 0; i < n; i++) v[i] = ipv[i];
	for (i = 0; i < n; i++) w[v[i]] = i;
	det = 1.0;
	for (i = 0; i < n - 1; i++) {
		j = v[i];
		if (j != i) {
			v[w[i]] = j; 
			w[j] = w[i]; 
			det = -det;
		}
	}
	for (i = 0; i < n; i++) det *= *(lu+n*ipv[i]+i);
	/* return */
	free( ipv );
	free( lu );
	free( w );
	free( v );
	return det;
}
/************************************************************************/

/**(2-2)*****************************************************************/
// imatrx(n, *a, nmax)	n:dimension, *a:double array nmax:a[nmax][nmax] //
// det = imatrx(n, a, nmax);						                    //
/************************************************************************/
double	imatrx(int n, double *a, int nmax)
{
 int	    i, j, k, mi, mk, *ipv, *w, *v;
 double 	*lu, s, t, det;

/*printf("\nimatrx()");
printf("\n*a=(%7.4f %7.4f %7.4f)",*a,*(a+1),*(a+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+nmax),*(a+nmax+1),*(a+nmax+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+2*nmax),*(a+2*nmax+1),*(a+2*nmax+2));
*/

	if (((lu = (double *)calloc(n * n, sizeof(double))) == NULL)
	  ||((ipv = (int *)calloc(n, sizeof(int))) == NULL)
	  ||((w = (int *)calloc(n, sizeof(int))) == NULL)
	  ||((v = (int *)calloc(n, sizeof(int))) == NULL)) {
		printf("memory overflow\n");
		exit(1);
	}
	/* LU decomposition */
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			*(lu+n*i+j) = *(a+nmax*i+j);
	for (k = 0; k < n; k++)
		ipv[k] = k;
	for (k = 0; k < n; k++) {
		i = k;
		s = fabs(*(lu+n*ipv[k]+k));
		for (j = k + 1; j < n; j++) {
			t = fabs(*(lu+n*ipv[j]+k));
			if (t > s) { i = j; s = t; }
		}
		j = ipv[k]; ipv[k] = ipv[i]; ipv[i] = j;
		mk = ipv[k];
		s = *(lu+n*mk+k);
		for (i = k + 1; i < n; i++) {
			mi = ipv[i];
			t = *(lu+n*mi+k) / s;
			*(lu+n*mi+k) = t;
			for (j = k + 1; j < n; j++)
				*(lu+n*mi+j) -= t * *(lu+n*mk+j);
		}
	}
	/* determinant */
	for (i = 0; i < n; i++) v[i] = ipv[i];
	for (i = 0; i < n; i++) w[v[i]] = i;
	det = 1.0;
	for (i = 0; i < n - 1; i++) {
		j = v[i];
		if (j != i) {
			v[w[i]] = j; 
			w[j] = w[i]; 
			det = -det;
		}
	}
	for (i = 0; i < n; i++) det *= *(lu+n*ipv[i]+i);
	/* inverse matrix */
	if (fabs( det ) > 1.0e-6) {
		for (k = 0; k < n; k++) {
			for (i = 0; i < n; i++) {
				mi = ipv[i];
				if (mi == k) t = 1.0;
				else	    t = 0.0;
				for (j = 0; j <= i - 1; j++)
					t -= *(lu+n*mi+j) * *(a+nmax*j+k);
				*(a+nmax*i+k) = t;
			}
			for (i = n - 1; i >= 0; i--) {
				mi = ipv[i];
				t = *(a+nmax*i+k);
				for (j = i + 1; j < n; j++)
					t -= *(lu+n*mi+j) * *(a+nmax*j+k);
				*(a+nmax*i+k) = t / *(lu+n*mi+i);
			}
		}
	}
	/* return */
	free( ipv );
	free( lu );
	free( w );
	free( v );
/*
printf("\nimatrx() inverse");
printf("\n*a=(%7.4f %7.4f %7.4f)",*a,*(a+1),*(a+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+nmax),*(a+nmax+1),*(a+nmax+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+2*nmax),*(a+2*nmax+1),*(a+2*nmax+2));
*/
	return( det );
}
/*******(2) imatrx() end ***********************************************/

/*******(3) Fourier() **************************************************/
// FourierWJ(=0`2)     Fourier('s',y,n,m,Fc,Fs)  (m)
//         Fc[k]=(1/)y(t)*cos(k*)d=2y(t)*cos(2k*x)dx
//         Fs[k]=(1/)y(t)*sin(k*)d=2y(t)*sin(2k*x)dx
//         (x=/2)
// Fourierϕ(L=0`2)   Fourier('t',y,n,m,Fc,Fs)  (m/Hz)
//******************************************************************/
//         !! ͕t   F[k]  = Fc[] - j*Fs[]             //
//******************************************************************/         
//         Fc[k] =y(t)*cos(k*)d=2΁y(t)*cos(2k*x)dx
//         Fs[k] =y(t)*sin(k*)d=2΁y(t)*sin(2k*x)dx
//         (x=/2)
//
// LŗUFx=0`1(s), dx=1/n(s); k=1`m=n/2
//       Fc[k]=C[k][0]+2*C[k][1]+2*C[k][2]+......+2*C[k][n-1]+C[i][n]
//         @C[k][i]=y[i]*cos(2k*i*dx)
//         WJFFc[k]*(1/n)    Fc[k]
//         ϕϊFFc[k]*       Fc[k]
//       Fs[k]=S[k][0]+2*S[k][1]+2*S[k][2]+......+2*S[k][n-1]+S[i][n]
//         @S[k][i]=y[i]*sin(2k*t)
//         WJFFs[k]*(1/n)    Fs[k]
//         ϕϊFFs[k]*       Fs[k]
// Œg df=2/n(Hz)  
//         y[i], i=0,1,...,n(>=2) : serial data
//         Fc[k],Fs[k], k=0,1,..,m<=n/2 : spectrum-cos, -sin
/***********************************************************************
Fourier(char sgn, double y[], int n, int m, double Fc[], double Fs[])
  { double pai=3.1415926535898e0, pai2=6.28318530718e0, p, pi;
    double c, s, c1, s1;
    int    i, j, k;

   c=0;
   for(i=1;i<n;i++) c=c+y[i];
   Fc[0]=(y[0]+2*c+y[n])/(n+n);
   Fs[0]=0;
   if(sgn=='t') Fc[0] = n*Fc[0]*pai2;
   for(k=1;k<=m;k++)
   {  p=k*pai2/n;
      pi=0;   c=0; s=0;
      for(i=1;i<n;i++)
        {pi=pi+p;  if(pi>pai2) pi=pi-pai2;
		 if(fabs(pi)<1.0e-5 || fabs(pi-pai2)<1.0e-5)  pi = 0;
	     c1 = y[i]*cos(pi); s1 = y[i]*sin(pi);
		 c = c + c1;   s = s + s1;
        }
	  //---- Fourier -----------------------------------//
	  if(sgn=='s') {  Fc[k]=(y[0]+2*c+y[n])/n; Fs[k]=2*s/n;  }
	  //---- Fourierϕ --------------------------------------------------//
	  if(sgn=='t') {  Fc[k]=(y[0]+2*c+y[n])*pai; Fs[k]=2*s*pai;  }
   }
}
/****** (3) Fourier() end ***********************************************/

/****** (4) InvFourier() ***************************************************/
// Fourier̘a     InvFourier('s',Fc[],Fs[],m,n,y[]) 
//        y(t)={Fc[k]*cos(k*)+Fs[k]*cos(k*)}
//            ={Fc[k]*cos(2k*x)+Fs[k]*cos(2k*x)}      (x=/2)
//      y[i]=H[i][0]+H[i][1]+H[i][2]+......+H[i][m-1]+H[i][m]
//        H[i][k]=Fc[k]*cos(2k*df*x)+Fs[k]*sin(2k*df*x)
//        (df=1(Hz), k=0`m),     (x=i*dx(s), dx=1/n(s), i=0 - n)
// Fourierϕ(tϊ) InvFourier('t',Fc[],Fs[],m,n,y[]) 
//        y(t)=(1/2){Fc[]*cos(t)+Fs[]*sin(t)}d
//            =2{Fc[]*cos(t)+Fs[]*sin(t)}d
//             (=-`+j     Fc[],Fs[] (m/(rad/s))
//            =(1/){Fc[]*cos(2f*x)+Fs[]*sin(2f*x)}df
//             (f=/2=0`)   Fc[],Fs[] (m/Hz)
//   LXyNg̐ϕF
//      y[i]=(H[i][0]+2*H[i][1]+2*H[i][2]+......+2*H[i][m-1]+H[i][m])/n
//        H[i][k]=Fc[k]*cos(2k*df*x)+Fs[k]*sin(2k*df*x)
//        (f=k*df df=1(Hz), k=0`m),    (x=i*dx, dx=1/n(s), i=0`n, x=0`1)
//        y[i]/(2)  y[i]
/****************************************************************************
void InvFourier(char sgn, double Fc[], double Fs[], int m, int n, double y[])
{
    int    i, k;
    double pai=3.1415926535898e0, pai2=6.28318530718e0, p, pi;

   if(sgn=='s')
   {
	   y[0] = 0;
       for(k=0;k<=m;k++) y[0] = y[0] + Fc[k];
       for(i=1;i<=n;i++)
	   {  p=i*pai2/n;
          pi=0;   y[i] = Fc[0];
          for(k=1;k<=m;k++)
		  {  pi=pi+p;  if(pi>pai2) pi=pi-pai2;
	         y[i] = y[i] + Fc[k]*cos(pi) + Fs[k]*sin(pi);
		  }
	   }
   }
   if(sgn=='t')
   {
	   y[0] = Fc[0] + Fc[m];
       for(k=1;k<m;k++) y[0] = y[0] + 2*Fc[k];
	   y[0] = y[0]*pai/m;
       for(i=1;i<=n;i++)
	   {  p=i*pai2/n;
          pi=0;   y[i] = 0;
          for(k=1;k<=m;k++)
		  {  pi=pi+p;  if(pi>pai2) pi=pi-pai2;
	         y[i] = y[i] + Fc[k]*cos(pi) + Fs[k]*sin(pi);
		  }
		  y[i] = (Fc[0] + 2*y[i] + Fc[m])/pai2/n;
	   }
   }
}
/******* (4) InvFourier() end ***************************************/

/*******(3-1) FourierS() **********************************************/
// FourierWJ FourierS(f[],n,m,Fc[],Fs[]) by trapezoid rule
// E x/X=(0-n)dx̒̔g`f(x)̃XyNgm߂
// E Fc[k]=(2/X)f(x)cos(2kx/X)dx,  Fc[0]=(1/X)f(x)dx
// E Fs[k]=(2/X)f(x)sin(2kx/X)dx
// E X=ndx,   x=idx,   (dx=1)
// E f[i](m),        i=0,1,...,n(>=2)   : data
// E Fc[k],Fs[k](m), k=0,1,...,m(<=n/2) : k-th spectrum -cos, -sin
/***********************************************************************/
FourierS(double f[], int n, int m, double Fc[], double Fs[])
{
   double pai=3.1415926535898e0, pai2=6.28318530718e0, p, pi;
   double c, s, c1, s1;
   int    i, k;

   c=0;
   for(i=1;i<n;i++) c=c+f[i];
   Fc[0]=(f[0]+2*c+f[n])/(n+n);
   Fs[0]=0;
   for(k=1;k<=m;k++)
   {  p=k*pai2/n;
      pi=0;   c=0; s=0;
      for(i=1;i<n;i++)
        {pi=pi+p;  if(pi>pai2) pi=pi-pai2;
	     c1 = f[i]*cos(pi); s1 = f[i]*sin(pi);
		 c = c + c1;   s = s + s1;
        }
      Fc[k]=(f[0]+2*c+f[n])/n;
	  Fs[k]=2*s/n;
     }
}
/****** (3-1) FourierS() end ********************************************/

/*******(4-1) InvFourierS() *********************************************/
// Fourier̘a InvFourierS(f[],n,m,Fc[],Fs[])
// E m̃XyNgx/X=(0-n)dx̒̔g`f(x)nċ߂
// E f(x)=Fc[k]cos(2kx/X)+Fs[k]sin(2kx/X)
// E X=ndx,   x=idx,   (dx=1)@
// E f[i](m),        i=0,1,...,n(>=2)   : g
// E Fc[k],Fs[k](m), k=0,1,...,m(<=n/2) : spectrum -cos, -sin of k-th Hz
/*************************************************************************/
InvFourierS(double f[], int n, int m, double Fc[], double Fs[])
{
   double pai=3.1415926535898e0, pai2=6.28318530718e0, p, pi;
   double c1;
   int    i, k;

   for(i=0;i<n;i++)
   {
	   f[i] = Fc[0];
	   p=i*pai2/n;
	   pi=0;
	   for(k=1;k<=m;k++)
	   {
         pi=pi+p;  if(pi>pai2) pi=pi-pai2;
	     c1 = Fc[k]*cos(pi) + Fs[k]*sin(pi);
		 f[i] = f[i] + c1;
       }
    }
}
/*******(4-2) InvFourierS() end *****************************************/

/*******(3-2) FourierT() ************************************************/
// Fourierϊ FourierT(f[],dt,n,m,Fc[],Fs[]) by trapezoid rule
// ET=ndt(s)̒̎Ԋ֐f(t)̃XyNgd=2/TԊum߂
// EF(j)=f(t)exp(-jt)dt=f(t)(cost-jsint)dt
// EF(j)=Fc()+jFs()
// EFc()=f(t)cos(t)dtC  Fs()=-f(t)sin(t)dt 
// Edt(s)  : ԍ
// Ef[i](m)                 i=0,1,...,n(>=2)   : f[^
// EFc[k],Fs[k](m/(rad/s)), k=0,1,...,m(<=n/2) : XyNg-cos, -sin
/************************************************************************/
FourierT(double f[], double dt, int n, int m, double Fc[], double Fs[])
{
   double pai=3.1415926535898e0, pai2=6.2831853071796e0, p, pi;
   double c, s, c1, s1;
   int    i, k;

   c=0;
   for(i=1;i<n;i++) c=c+f[i];
   Fc[0]=(f[0]+2*c+f[n])*dt/2;
   Fs[0]=0;
   for(k=1;k<=m;k++)
   {  p=k*pai2/n;
      pi=0;   c=0; s=0;
      for(i=1;i<n;i++)
        {pi=pi+p;  if(pi>pai2) pi=pi-pai2;
	     c1 = f[i]*cos(pi); s1 = f[i]*sin(pi);
		 c = c + c1;   s = s + s1;
        }
      Fc[k] = (f[0] + 2*c + f[n])*dt/2;     Fs[k]=-s*dt;
     }
}
/*******(3-2) FourierT() end *******************************************/

/*******(4-2) InvFourierT() ********************************************/
// Fouriertϊ InvFourierT(f[],dom,n,m,Fc[],Fs[]) by trapezoid rule
// Edom݂m̃XyNg0`T=2/dom(s)nāC
//   ԊԊudt=T/nŎԊ֐f(t)߂
// Ef(t)=1/(2)F(j)exp(jt)d  (-<<)
//       =2/(2){Fc()cost-Fs()sint}d   (0<<)
//       ={Fc()cost-Fs()sint}d/΁@     (0<<)
// E=kd,     =md
// ET=2/d,   dt=T/n=2/(nd),  t=idt=2i/(nd)
// Et=2ki/n
// EF(j)=Fc()+jFs()
// Edt(s)  : discrete time pitch
// Ef[i](m),                i=0,1,...,n(>=2)   : g`
// EFc[k],Fs[k](m/(rad/s)), k=0,1,...,m(<=n/2) : XyNg-cos, -sin
/***********************************************************************/
InvFourierT(double f[], double dom, int n, int m, double Fc[], double Fs[])
{
   double pai=3.1415926535898e0, pai2=6.2831853071796e0, p, pi;
   double c, c1, T, dt;
   int    i, k;

   T  = pai2/dom;
   dt = T/n;
   for(i=0;i<n;i++)
   {
	   p=i*pai2/n;
	   pi=0;   c=0;
	   for(k=1;k<m;k++)
	   {
           pi=pi+p;  if(pi>pai2) pi=pi-pai2;
	       c1 = Fc[k]*cos(pi) - Fs[k]*sin(pi);
           c = c + c1;
        }
      f[i] = (Fc[0] + 2*c + Fc[m]*cos(pi+p) - Fs[m]*sin(pi+p))*dom/pai2;
     }
  }
/*******(4-2) InvFourierT() end ******************************************/


/****(6)****************************************************************/
// drawfigure(r0[], wy, n, a[]) : łȂ̉~̐UuԐ}   //
//    ux_||~||EEEEE|~||x_v̕`             //
//    r0[] : ʏ̌̍[ʒui}̌_j                          //
//    wy@ : YiUj̕`{iʑŜ̑傫=2~2j            //
//    n    : ~i}Xj̐iRxj                                //
//    a[]  : e~i}Xj̐U                                        //
/***********************************************************************/
void drawfigure(double r0[], double wy, int n, double a[])
{
	double  dx, r1[2], r2[2];
	int     i;
	float   red[]={1.0, 0.0, 0.0, 0.0};

	//-------- Œ_E}XEŒ_Ԃ̌` ---------//
	dx = (xedge - r0[0])/(n+1); 
	r2[0] = r0[0];   r2[1] = r0[1];
	for(i=0;i<n;i++)
	{
		r1[0] = r2[0];        r1[1] = r2[1];
		r2[0] = r1[0] + dx;   r2[1] = r0[1] + wy*a[i]; 
	    usrDrawLine2d( r1, r2, red );
	}
	r1[0] = r2[0];        r1[1] = r2[1];
	r2[0] = xedge;        r2[1] = r0[1];
    usrDrawLine2d( r1, r2, red );
	
    //---------- UE[ɌŒ_` ---------------//
	usrDrawSolidCircle2d( r0, 0.01, red );
	usrDrawSolidCircle2d( r2, 0.01, red );

	//---------- }X̕` ---------------------------//
	r1[0] = r0[0];
	for(i=0;i<n;i++)
	{
		r1[0] = r1[0] + dx;   r1[1] = r0[1] + wy*a[i];
	    usrDrawSolidCircle2d( r1, 0.04, ncolor[i] );
	}
	glFlush();
}
/********** (6) drawfigure() end ********************************/

/****(7)***************************************************************/
// drawcurve1(r0[], wx, wy, m, a[] color[]) : 1{̐UȐOt` //
//    莞ԊԊua(t)̋Ȑ`                                  //
//    r0[] : ʏ̐UOt̍[ʒu(_j                      //
//    wx   : X̍                                            //
//    wy[] : Ya[k][]̕`{(2~2j                         //
//    m    : ()̍ݐ(k=0,1,...,m)̓_`                //
//    a[i] : iԖڋȐkԖڂ̓_̐U                               //
/**********************************************************************/
void drawcurve1( double r0[], double wx, double wy, int m, double a[], float color[] )
{
	int k;
	double r1[2], r2[2];

	glLineWidth(2.0);       	//`悷̑w肷

	//------- דm̓_𒼐łȂ ----------------------//
	r2[0] = r0[0];  r2[1] = r0[1] + a[0]*wy;
	for(k=1;k<=m;k++)
	{
		r1[0] = r2[0];         r1[1] = r2[1];
		r2[0] = r1[0] + wx;    r2[1] = r0[1] + a[k]*wy;
		usrDrawLine2d( r1, r2, color );
	}
}
/********** (7) drawcurve1() end ****************************************/

/****(8)*****************************************************************/
// drawcurven(r0[], wx, wy[], n, m, *a, mmax) : n{̐UȐOt` //
//    莞ԊԊun{a(i,t)̋Ȑ`                             //
//    r0[] : ʏ̐UOt̍[ʒu(_j                        //
//    wx   : X̍                                              //
//    wy   : Ya[]̕`{(2~2j                              //
//    n    : `悷Ȑ̐                                           //
//    m    : ()̍ݐ(k=0,1,...,m)̓_`                  //
//    *a=a[i][k] : iԖڋȐkԖڂ̓_̐U                           //
//    color[4]   : `̐F                                             //
/************************************************************************/
void drawcurven( double r0[], double wx, double wy[], int n, int m, double *a, int mmax )
{
	int   i;

	//--------- n{̋Ȑ` ---------------------------//
	for(i=0;i<n;i++)
	{
       drawcurve1( r0, wx, wy[i], m,  (a+i*mmax), ncolor[i] );
	}
}
/********* (8) drawcurven() end *****************************************/

/****(9)***********************************************************/
// drawcurve0(r0[], wx, wy, m, *a) :  a[x,y][]̓_̕`        //
//    r0[] : ʏ̌_                                         //
//    (wx, wy) : (X,Y)̕`{(ʍő2~2j                 //
//    m    : _̐(k=0,1,...,m)̓_𒼐ԕ`                //
//    *a=a[0,1][k] : kԖڂ̓_[x,y]l                           //
/******************************************************************/
//	drawcurve0(rp, wxp, wyp, mp, pseries, MMAX2 );
void drawcurve0( double r0[], double wx, double wy, int m, double *a, int mmax )
{
	double r1[2], r2[2];
	int    k;

	glLineWidth(2.0);       	//`悷̑w肷

	//------- דm̓_𒼐łȂ ----------------------//
	r2[0] = r0[0] + *a*wx;
	r2[1] = r0[1] + *(a+mmax)*wy;
	for(k=1;k<=m;k++)
	{
		r1[0] = r2[0];                r1[1] = r2[1];
		r2[0] = r0[0] + *(a+k)*wx;    r2[1] = r0[1] + *(a+mmax+k)*wy;
		usrDrawLine2d( r1, r2, black );
	}
}
/********* (9) drawcurve0() end ******************************************/

/********* (10) **********************************************************/ 
// drawbargraph(rf[], wf, wa, m, a[]) : m{̖_Ot`              //
//    rf[] : `挴_                                                    //
//    wf   : ݁i_̊Ԋuj                                        //
//    wa   : c{                                                    //
//    m    : _̐                                                      //
//    a[]  : e_̑傫                                                //] 
/*************************************************************************/
void drawbargraph(double rf[], double wf, double wa, int m, double a[])
{
	double r1[2], r2[2];
	int    k;

	glLineWidth(2.0);       	//`悷̑w肷

	//------- a[k]̖_` ----------------------//
	r1[0] = r2[0] = rf[0] - wf;
	r1[1] = rf[1];
	for(k=0;k<=m;k++)
	{
		r1[0] = r1[0] + wf;
		r2[0] = r1[0];        r2[1] = r1[1] + a[k]*wa;
		usrDrawLine2d( r1, r2, red );
	}
}
/********* (10) drawbargraph() end ***************************************/



/********* (11)  *********************************************************/
// drawfreqcurve1(r0[],wx,wy[],m,n,a[][],mmax) : n{̎g`     //
//   n{̎gUԊuŕ`                               //
//   r0[0,1]: _ʒu                                                   //
//   wx@   : {i1rad/s=wx)                                       //
//   wy[]   : eȐ̏c{(m)                                          //
//   m      : ݂̐                                               //
//   n      : Ȑ̐                                                   //
//   a[n][mmax] : n{Ȑ̐U                                        // 
//   mmax   : z̐iő协ݐ,feseries[NFREE][mmax])                //
/*************************************************************************/
void drawfreqcurve(double r0[], double wx, double wy[], int m, int n, double *a, int mmax)
{
	int i, k;
	double r1[2], r2[2];

	glLineWidth(2.0);       	//`悷̑w肷

	//--------- n{̋Ȑ` ---------------------------//
	for(i=0;i<n;i++)
	{
		//------- דm̓_𒼐łȂ ----------------------//
		r2[0] = r0[0];  r2[1] = r0[1] + *(a+i*mmax)*wy[i];
		for(k=1;k<=m;k++)
		{
			r1[0] = r2[0];         r1[1] = r2[1];
			r2[0] = r1[0] + wx;    r2[1] = r0[1] + *(a+i*mmax+k)*wy[i];
			usrDrawLine2d( r1, r2, ncolor[i] );
		}
	}
}
/************* (11) drawfreqcurve() end ***************************************/


/******** (12) ****************************************************************/
/******************************************************************************/
// Kzf[^i=0CU=1j̈Å֐Q                         //
//   (12-1) UniformtoGauss() : lzf[^琳Kzf[^ɕϊ         // 
//   (12-2) Gaussian()       : Kzf[^̐                           //
//   (12-3) readrandom()     : (12-1)̂߂̑Ή\t@Cǂݍ     // 
//  Ey = errf(x) = (2)exp(-x^2/2)dx                                    //
//  Ey(0`0.5)lzƂΏ㎮x(0`),U^2=1̐KzƂȂ  //
//  Ey=errf(x)̑Ή\}ɂ肙𐶐x߂                    //
//  EΉ\̓t@Cɂ̂Ŕzɓǂݍ(֐ readrandom())             //
/******************************************************************************/

/******************************************************************************/
char        normal01[32]="normal01.data";
char        normal12[32]="normal12.data";
char        normal23[32]="normal23.data";
char        normal34[32]="normal34.data";
char        normal45[32]="normal45.data";
double      x01[50][2], x12[50][2], x23[50][2], x34[50][2], x45[50][2];
int         krdm1, krdm2, krdm3, krdm4, krdm5;

/************* (12-1) UniformtoGauss() ****************************************/
//    lz_琳Kz_̕ϊ                          //
//    y = errf(x) = (2)exp(-x^2/2)dx                                    //
//    y(0`0.5)lzƂΏ㎮x(0`),U^2=1̐KzƂȂ  //
//    (x,y)Ή\y=rand()^x}ɂ苁߂                      //
/******************************************************************************/
double UniformtoGauss( double yy )
{
	double  ya, dx, xa, xx;
	int     k;

	ya = fabs(yy);
	if(ya<1.0e-3)  return (0.4*yy);
	if(ya<0.1) goto p1;
	if(0.1<=ya && ya<0.2) goto p2;
	if(0.2<=ya && ya<0.3) goto p3;
	if(0.3<=ya && ya<0.4) goto p4;
	if(0.4<=ya) goto p5;

p1:
	for(k=0;k<=krdm1;k++)
	{
		if(x01[k][1]<=ya && ya<=x01[k+1][1]) break;
	}
	dx = (x01[k+1][0]-x01[k][0])/(x01[k+1][1]-x01[k][1]) * (ya-x01[k][1]);
	xa = x01[k][0] + dx;
	xx = xa*yy/ya;
/*
printf("\nx01[%2d][0,1]=(%7.4f %7.4f)",k,x01[k][0],x01[k][1]);
printf("\nx01[%2d][0,1]=(%7.4f %7.4f)",k+1,x01[k+1][0],x01[k+1][1]);
printf("\n  xx,yy      =(%7.4f %7.4f)",xx,yy);
*/
    return xx;

p2:
	for(k=0;k<=krdm2;k++)
	{
		if(x12[k][1]<=ya && ya<=x12[k+1][1]) break;
	}
	dx = (x12[k+1][0]-x12[k][0])/(x12[k+1][1]-x12[k][1]) * (ya-x12[k][1]);
	xa = x12[k][0] + dx;
	xx = xa*yy/ya;
/*
printf("\nx12[%2d][0,1]=(%7.4f %7.4f)",k,x12[k][0],x12[k][1]);
printf("\nx12[%2d][0,1]=(%7.4f %7.4f)",k+1,x12[k+1][0],x12[k+1][1]);
printf("\n  xx,yy      =(%7.4f %7.4f)",xx,yy);
*/
    return xx;

p3:
	for(k=0;k<=krdm3;k++)
	{
		if(x23[k][1]<=ya && ya<=x23[k+1][1]) break;
	}
	dx = (x23[k+1][0]-x23[k][0])/(x23[k+1][1]-x23[k][1]) * (ya-x23[k][1]);
	xa = x23[k][0] + dx;
	xx = xa*yy/ya;
/*
printf("\nx23[%2d][0,1]=(%7.4f %7.4f)",k,x23[k][0],x23[k][1]);
printf("\nx23[%2d][0,1]=(%7.4f %7.4f)",k+1,x23[k+1][0],x23[k+1][1]);
printf("\n  xx,yy      =(%7.4f %7.4f)",xx,yy);
*/
    return xx;

p4:
	for(k=0;k<=krdm4;k++)
	{
		if(x34[k][1]<=ya && ya<=x34[k+1][1]) break;
	}
	dx = (x34[k+1][0]-x34[k][0])/(x34[k+1][1]-x34[k][1]) * (ya-x34[k][1]);
	xa = x34[k][0] + dx;
	xx = xa*yy/ya;
/*
printf("\nx34[%2d][0,1]=(%7.4f %7.4f)",k,x34[k][0],x34[k][1]);
printf("\nx34[%2d][0,1]=(%7.4f %7.4f)",k+1,x34[k+1][0],x34[k+1][1]);
printf("\n  xx,yy      =(%7.4f %7.4f)",xx,yy);
*/
    return xx;

p5:
	for(k=0;k<=krdm5;k++)
	{
		if(x45[k][1]<=ya && ya<=x45[k+1][1]) break;
	}
	dx = (x45[k+1][0]-x45[k][0])/(x45[k+1][1]-x45[k][1]) * (ya-x45[k][1]);
	xa = x45[k][0] + dx;
	xx = xa*yy/ya;

/*
printf("\nx45[%2d][0,1]=(%7.4f %7.4f)",k,x45[k][0],x45[k][1]);
printf("\nx45[%2d][0,1]=(%7.4f %7.4f)",k+1,x45[k+1][0],x45[k+1][1]);
printf("\n  xx,yy      =(%7.4f %7.4f)",xx,yy);
*/
    return xx;
}
/************* (12-1) UniformtoGauss() end ************************************/

/************** (12-2) Gaussian() *********************************************/
//     琳Kzf[^𐶐                                           //
//     ̊֐𗘗pOreadrandom()s                           //
/******************************************************************************/
double Gaussian(void)
{
	double  random, xx;
	random = (rand() - 16384)/32768.0;
	xx = UniformtoGauss(random);
	return xx;  
}
/************** (12-2) Gaussian() end ***************************************/

/****************** (12-3) readrandom() *************************************/
// _f[^ϊ\t@Cz֓ǂݍ                         //
//    t@C͂̃t@CƓ[NXy[XɓĂ                //
//    x01[50][2] : lz(0`0.1)                                         //
//    x12[50][2] : lz(0.1`0.2)                                       //
//    x23[50][2] : lz(0.2`0.3)                                       //
//    x34[50][2] : lz(0.3`0.4)                                       //
//    x45[50][2] : lz(0.4`0.5)                                       //
/****************************************************************************/
void readrandom(void)
{
    FILE*fp;
	int    k;

   fp=fopen(normal01,"rt");
   fscanf(fp, "%d",&krdm1);
   for(k=0;k<=krdm1;k++)   fscanf(fp,"%lf %lf",&x01[k][0],&x01[k][1]);
   fclose(fp);
   fp=fopen(normal12,"rt");
   fscanf(fp, "%d",&krdm2);
   for(k=0;k<=krdm2;k++)   fscanf(fp,"%lf %lf",&x12[k][0],&x12[k][1]);
   fclose(fp);
   fp=fopen(normal23,"rt");
   fscanf(fp, "%d",&krdm3);
   for(k=0;k<=krdm3;k++)   fscanf(fp,"%lf %lf",&x23[k][0],&x23[k][1]);
   fclose(fp);
   fp=fopen(normal34,"rt");
   fscanf(fp, "%d",&krdm4);
   for(k=0;k<=krdm4;k++)   fscanf(fp,"%lf %lf",&x34[k][0],&x34[k][1]);
   fclose(fp);
   fp=fopen(normal45,"rt");
   fscanf(fp, "%d",&krdm5);
   for(k=0;k<=krdm5;k++)   fscanf(fp,"%lf %lf",&x45[k][0],&x45[k][1]);
   fclose(fp);

   printf("\n_ϊ\ǂݍ݊");
//   printf("\nx45[%d][0,1]=(%7.4f %7.4f)",krdm5,x45[krdm5][0],x45[krdm5][1]);
}
/**************** (12-3) readrandom() end *************************************/

/**************** (12) end ****************************************************/
/******************************************************************************/