/*************************************************************************/
/* correlation.c vibfunc.h  graph2d.h                       2005.12.05   */
/* random vibration by Gaussian noise or LPF noise input x(t)            */
/* EAutocorrelation and cross correlation of input-output x(t), y(t)    */
/* EWindow=d : do-nothing window, =b : Bartlett window                  */
/* EPower spectrum, cross power spectrum of x(t), y(t)                  */
/* ETransfer function G(j), coherency (j)                         */
/* Use Gaussian(), FourierT(y[],n,m,Fc[],Fs[]) in vibfunc.h              */
/* y[0-n] : autocorrelation data of 1DOF-vibration system response(n<601)*/
/*          (>0)                                                       */
/* Fc[0-m],Fs[] : Power spectrum cos, sin (Fs[]=0)    m<=n/2             */
/*************************************************************************/


/*****************************************************************************/
#include    <stdio.h>
#include    <conio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             //
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
    float  pink[]  ={1.0, 0.0, 0.5, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          601
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

double    t, dt, DT;
double    tau;                         //Px̎萔 G=1/(1+jу)
double    om0, zeta, zeta2;            //ŗLU(=1rad/s)C, 2
double    Fex;                         //O(N)Ct̂Ƃ̊O͐U(nrkg*DT(s)Ԉێj
double    yy0[3], yy1[3], yy2[3];      //ԕϐ x(t), y(t), 
double Aseries[2][MMAX], Bseries[2][MMAX];    //_̎n
double    THCORR[2][MMAX];             //_IȊÓEȑ֊֐ Cxx,Cyy
double    THCCORR[MMAX];               //_Iȑݑ֊֐ Cxy
double    THPSD[3][MMAX];              //_IȊÓEȁE݃XyNgx Pxx,Pyy,Pxy
double    APSD[2][MMAX];               //ÓE̐UXyNgx APxx=|X|^2,APyy=|Y|^2
double    PSD[2][MMAX], CPSD[MMAX];    //ÓEȁE݃XyNgx Pxx,Pyy,Pxy
double    COH[MMAX];                   //coherency=Pxy/(Pxx*Pyy)
double    Fc[MMAX], Fs[MMAX];          //ƕϐFXyNg̎E
double    Pc[2][MMAX], Ps[2][MMAX];    //ƕϐFXyNgx̎E
double    CPc[MMAX], CPs[MMAX];        //ƕϐF݃XyNgx̎E
double    Ffr, Afr, Ffrav, Afrmax;     //XyNg̕ϒlEől
double   corr[2][MMAX];                //ÓE̎ȑ֊֐ Cxx, Cyy
double   CORR[2][MMAX], CORRW[2][MMAX];//̐KEwinowl
double   ccorrp[MMAX], ccorrm[MMAX];   //ݑ֊֐ȋƕ̑)
double   CCORRP[MMAX], CCORRM[MMAX], CCORR[MMAX], CCORRW[MMAX];//Kݑ֊֐
double   G1[MMAX],  G2[MMAX];          //`B֐G1=sqrt(Pyy/Pxx), G2=sqrt(APyy/APxx)
double   G3[MMAX],  G4[MMAX];          //`B֐G3=Pxy/Pxx, G4=Pyy/Pxy
double   THG[MMAX], THPH[MMAX];        //_Iȓ`B֐̐UEʑ
double   PH3[MMAX], PH4[MMAX];         //`B֐̈ʑG3, G4
double   var[2], thvar[2];             //ÓE̕Ux^2,y^2, ̗_l
                                       //|Gx,y(j)|^2=thvar[0,1]*Fourier[Cxx(t),Cyy(t)]
double   nnoise, thnnoise;             //FO̓XyNgx, ̗_lN^2==/
 
int    nrkg=4;             //nrkg*dtRKGvZ
int    n1, n2, mp;         //ő僉OĈQ{CőU̐
int    mq;                 //`B֐`̍ő_
double Tn;                 //ő僉O(=n1*DT)
int    m0;                 //0łP(2/0b)̃f[^
int    nav;                //f[^荞݁E֌vŽJԂiOƂ̘a̕ρj
int    nn;                 //S荞݃f[^(=nav*n1)
double dom, omp;           //XyNg̍ݐEvZőU(=mp*dom)
double OMMAX;              //vZ\ȍőU(=n1*dom)
char   sgnf;               //O͂̑I(FG w or PxG l)
char   sgng;               //`B֐(g)orO(gȊO)`̑I
char   window;             //EBh[̑I(DN-window d,  Bartlet-window b)
int    nt;                 //UȐ`̍ݐ(nf*wt=1)
double wt;                 //ÓEE֊֐Ȑ`̉
double wa, wb, wc, wd;     //ÓE֊֐CÓE̐UȐ`̏c{
double wom;                //XyNg`̉ݕ
double wsp, wsw;           //ÓẼXyNg`̏c{
double r0[2];              //`̊_
double ra[2], rb[2];       //ÓȆ֊֐`̌_
double re[2];              //ݑ֊֐`̌_
double rc[2], rd[2];       //EO͐UȐ`̌_
double rp[2], rq[2], rs[2];//EUE݊eXyNg`̌_
double rw[2], ru[2];       //O̓XyNgEO͐UXyNg`̌_
double rt[2], rv[2];       //LƕĂS̓`B֐̌_CRq[V̌_
double r1[2], r2[2];       //ƕϐ
int    MotionSign;
unsigned char KEY;
void   dialogue();
//double xedge=0.99;

/************** ̉ *********************************************/
//@UIO͂̂Ƃ̔   dyi/dt = fi(t,y,Fex)
//@O͒l莞ԂɈlۂ
//@̉@disrkg()𗘗p
//  i : Ԗڂ̔
//@t : 
//@y[] : ԕϐ
//  cnt=0 : O͈lۂD0 : O͒lς
/***************************************************************************/
double f(int i, double t, double y[], int cnt)
{
	static double F, yy;

	//------ FKEXmCYɑ΂鉞 -----------//
	if(sgnf=='w')
	{
		if(i==0)   return y[1];
	    //----- cnt=0ȊO͊O͂ɕۂ --//
        if(i==1) { if(cnt==0) Fex = Gaussian();
		           else       Fex = Fex;
				   yy = Fex - (zeta2*y[1] + y[0]);
				   return yy;
		}
    	if(i==2)   return (0);
	}
	//------ PxtB^mCYɑ΂鉞 --------//
	if(sgnf=='l')
	{
		if(i==0)   return y[1];
        if(i==1) { Fex = y[2];
			       yy = y[2] - (zeta2*y[1] + y[0]);
		           return yy; }
	    //------- cnt=0ȊO͊O͂ɕۂ -------//
    	if(i==2) { if(cnt==0) F = Gaussian();
		           else       F = F;
		           yy = (F - y[2])/tau;
		           return yy; }
	}
   	return yy;
}
/************* f() end *******************************************************/

/************* o̗͂_IȃXyNǧvZ ******************************/
//   thspectrum(dom, m, yy[0,1,2][MMAX]) 
//     d֍݂ŁC0-m܂ł̐UɂăXyNgyy[][]vZ
//     yy[0][] : O̓XyNg Pxx
//     yy[1][] : XyNg Pyy=|G|^2*Pxx
//     yy[2][] : ݃XyNg Pxy=|G|*Pxx
//     thg[]   : `B֐̐U |G|
//     thph[]  : `B֐̈ʑ G
//     n̋U_0=1rad/s
/*****************************************************************************/
void thspectrum(double dom, int m, double yy[3][MMAX], double thg[], double thph[])
{
	static double om, om2;
	static int    i;

	thnnoise = PAI/OMMAX;     //FmCY(^2=1)̃XyNgx N^2=/
	//=========== `B֐U thg[], ʑ thph[] ====================//
	for(i=0;i<=m;i++)
	{
		om = i*dom;		om2 = om*om;
		if(fabs(om-1)<1.0e-6 && zeta==0) { thg[i] = 1.0e5; thph[i] = PAI/2; }
		else {  thg[i] = 1/sqrt( (1-om2)*(1-om2) + zeta2*zeta2*om2 );
 		       thph[i] = atan2( zeta2*om, 1-om2 ); }
	}
	//=================== ́FmCŶƂ ===============================//
	if(sgnf=='w') for(i=0;i<=m;i++)
	{
		om = i*dom;		om2 = om*om;
		//---------- O͈lXyNgx Pxx=/ ----------------------//
		yy[0][i] = thnnoise;
		//---------- XyNgx Pyy, UXyNg |Y| --------//
		yy[1][i] = thnnoise*thg[i]*thg[i];
		yy[2][i] = thnnoise*thg[i];
	}
	//=================== ÓPxmCŶƂ =========================//
	if(sgnf=='l') for(i=0;i<=m;i++)
	{
		om = i*dom;		om2 = om*om;
		//---------- O̓XyNgx Pxx=/*(1+(у)^2) -------------//
		yy[0][i] = thnnoise/(1 + tau*tau*om2);
		//---------- XyNgx Pyy, UXyNg |Y| --------//
		yy[1][i] = yy[0][i]*thg[i]*thg[i];
		yy[2][i] = yy[0][i]*thg[i];
	}
}
/********* thspectrum() end ***************************************************/

/************* _Iȉ̎ȑ֊֐̌vZ ******************************/
//    DT݂ŁC0-n܂ł̃OԂɂĊÓȆ֊֐yy[0,1][]vZ //
//    thvar[0,1] : =Cxx[0], Cyy[0]=x^2Cy^2
/*****************************************************************************/
void thcorrelation(double DT, int n, double yy[2][MMAX])
{
	static double t, OM, al, al2, eta1, eta2, a, b, c, B, D, ab;
	static int    i;

	if(zeta==1)  zeta = 1.001;
	if(zeta<1)   OM = sqrt(1 - zeta*zeta);
	if(zeta>1){  OM = sqrt(zeta*zeta - 1);
		         eta1 = zeta - OM;
	             eta2 = zeta + OM; }

	//---------- FmCYO͂̂Ƃ ----------------------------------------//
	if(sgnf=='w') for(i=0;i<=n;i++)
	{
		t = i*DT;
		if(i==0) yy[0][0] = 1;  else yy[0][i] = 0;
		if(zeta<1) yy[1][i] = (cos(OM*t) + zeta/OM*sin(OM*t))*exp(-zeta*t);
		else       yy[1][i] = (eta2*exp(-eta1*t) - eta1*exp(-eta2*t))/(eta2 - eta1);
	}
	//---------- PxmCYO͂̂Ƃ ------------------------------------//
	if(sgnf=='l')
	{
		al = 1/tau;
		if(al==zeta)  al = al + 0.001;
		if(zeta<1)
		{
			//--------- _IȃXyNgxPyy()̋tFourierϊ -------//
			//   Cyy(t)=a*exp(-t)+{b*cos(t)+c*sin(t)}*exp(-t)       //
			al2 = al*al;
            D=al2*(al2+2*(1-2*zeta*zeta))/(al2*al2+2*(1-2*zeta*zeta)*al2+1);
            B=al2*(D-1);
            a=-B/(2*al); b=(B+D)/(4*zeta); c=-(B-D)/(4*OM);
            ab = a + b; a = a/ab; b = b/ab; c = c/ab;  //Cxx(0)=1֕ϊ
			thvar[0] = al/2*thnnoise;
			thvar[1] = ab;
/*
printf("\n藝 y(0)=%7.4f",a+b);
printf("\n            dy(0)=%7.4f",-al*a-zeta*b+OM*c);
printf("\n           ddy(0)=%7.4f",al*al*a+(zeta*zeta-OM*OM)*b-2*zeta*OM*c);//getch();
*/
		    for(i=0;i<=n;i++)
			{
			 t = i*DT;
		     yy[0][i] = exp(-al*t);
		     yy[1][i] = a*exp(-al*t) + (b*cos(OM*t) + c*sin(OM*t))*exp(-zeta*t);
            }
		}
		if(zeta>1)
		{
			a = 1/(1 + al*al - 2*al*zeta);
			b = al*eta2*(al - eta2)/(2*OM*(1 + al*al - 2*zeta*al));
			c = al*eta1*(eta1 - al)/(2*OM*(1 + al*al - 2*zeta*al));
/*
printf("\n藝 y(0)=a+b+c=%7.4f",a+b+c);
printf("\n            dy(0)=-a-1b+2c=%7.4f",-al*a-eta1*b-eta2*c);
printf("\n           ddy(0)=^2a+(^2-^2)b-2ăc=%7.4f",al*al*a+eta1*eta1*b+eta2*eta2*c);getch();
*/
			for(i=0;i<=n;i++)
			{
			 t = i*DT;
		     yy[0][i] = exp(-al*t);
		     yy[1][i] = a*exp(-al*t) + b*exp(-eta1*t) + c*exp(-eta2*t);
            }
		}
	}
}
/********* thcorrelation() end ***********************************************/

/********* corrandspectrum() *************************************************/
	//-------------------------------------------------------------//
	// f[^n1ƂCÕf[^ƕn2ő֌vZ            //
	//   (1) ֊֐ƃp[XyNgvZ                        //
    //       corr[0,1][i](i=0`n1) : Cxx[i], Cyy[i]                //
    //       ccorrp[i], ccorrm[i]  : Cxy[i], Cyx[i]                //
    //       corr[i]𕉑ɐ܂ԂCwindow遨CORRW[i]     //
    //       ccorrm[i],ccorrp[i]܂Ƃ߁Cwindow遨CCORRW[i]//
	//       PSD[0,1][k]=Fourier(CORRW[0,1][i]) : Pxx, Pyy         //
	//       CPSD[k]=Fourier(CCORRW[i]) : Pxy                      //
    //    E `̂߂                                          //
    //       corr[0,1][i]𐳋KCORR[0,1][i] (0`n1)            //
    //       ccorrm[i],ccorrp[i]𐳋KCCORRM[i],CCORRP[i]      //
	//   (2) f[^̃XyNg̕όvZ                        //
    //       Fr[k]=Fourier(y[i])^2  APSD[k]=Fr[k]/nav          //
	//-------------------------------------------------------------//
/****** data() ****************************************************************/
// data(yy0[])                                                                //
// Eyy0[]      : vZ̏l                                                //
// Eyy0[]n܂UidtԊuŁj1`n1vZo͂Aseries[0,1][]   //
// EBseries[][n1-n2]Bseries[][0-n1], Aseires[][1-n1]Bseries[][n1-n2] //
/******************************************************************************/
void data(double yy0[])
{
	static int i, j, k;

	//------------ f[^n1ւ炷 -----------------------//
	for(i=0;i<=n1;i++) { Bseries[0][i] = Bseries[0][n1+i];
	                     Bseries[1][i] = Bseries[1][n1+i]; }
	//---------(1) n1̓o̓f[^Aseries[0,1][1-n1] -------------//
	for(k=0;k<3;k++) yy2[k] = yy0[k];
    for(i=1;i<=n1;i++)
	{
	   //--- nrkg*dtɃf[^擾Aseries[0,1][i] -------//
        for(j=0;j<nrkg;j++)
		{
		   for(k=0;k<3;k++) yy1[k] = yy2[k];
	       disrkg( t, dt, yy1, yy2, 3, j);
	       t = t + dt;
		}
	    Aseries[0][i] = Bseries[0][n1+i] = Fex;        //̓f[^
	    Aseries[1][i] = Bseries[1][n1+i] = yy2[0];     //o̓f[^
	}
	//-------- vZ̏l ------------------------//
	yy0[0] = yy2[0]; yy0[1] = yy2[1]; yy0[2] = yy2[2];

}
/************** data() end ********************************************/

/********** correlation() ***********************************************/
//   corr[0][i]=corr[0][i]+x[i]x[i+j] (i,j=0`n1) O͂̎ȑ֊֐
//   corr[1][i]=corr[1][i]+y[i]y[i+j] (i,j=0`n1) ̎ȑ֊֐
//   ccorrp[i]=ccorrp[i]+x[i]y[i+j] (i,j=0`n1) o͊Ԃ̑ݑ֊֐
//   ccorrm[i]=ccorrm[i]+x[i+i]y[i] (i,j=0`n1) o͊Ԃ̑ݑ֊֐
//   corr[0,1][i](0`n1)𐳋KCORR[0,1][i] (0`n1)  
//   ccorrp,m[i] (0`n1)𐳋KCCORRP,M[0,1][i] (0`n1)  
//   var[0,1]=corr[0,1][0] : o͂̕Ux^2,y^2
//      FmCŶƂ_lx^2=1C   y^2=x^2/(4)
//      LPFmCŶƂ _lx^2=/2Cy^2=-B/(2)+(B+D)/(4)
//           =1/, D={^2+2((1-2)}^2/{^4+2(1-2)^2+1}
//                      @@B=^2(D-1)
//   sxy : xy^2=xy
/************************************************************************/  
void correlation( )
{
	int    i, j, k;
	double cxx, cyy, cxy, cyx, sxy;

    //-------- (1) ȁEݑ֊֐̍XV ----------------//l//
	for(j=0;j<=n1;j++)
	{
    	cxx = cyy = cxy = cyx = 0;
		for(i=1;i<=n1;i++)
		{
			cxx = cxx + Bseries[0][n1-j+i]*Bseries[0][n1+i];  //Cxx()
			cyy = cyy + Bseries[1][n1-j+i]*Bseries[1][n1+i];  //Cyy()
			cxy = cxy + Bseries[0][n1-j+i]*Bseries[1][n1+i];  //Cxy()
			cyx = cyx + Bseries[1][n1-j+i]*Bseries[0][n1+i];  //Cyx()
		}
		corr[0][j]  = (nn*corr[0][j] + cxx)/(nn + n1);        //Cxx()
		corr[1][j]  = (nn*corr[1][j] + cyy)/(nn + n1);        //Cyy()
		ccorrp[j]   = (nn*ccorrp[j]  + cxy)/(nn + n1);        //Cxy()
		ccorrm[j]   = (nn*ccorrm[j]  + cyx)/(nn + n1);        //Cyx()
   }
	var[0] = corr[0][0];       //x^2
	var[1] = corr[1][0];       //y^2
	sxy = sqrt(var[0]*var[1]);
  //------------- corr[][0]=1ɐKCORR[][] ---------------------//
   for(j=0;j<=n1;j++)
   {  for(k=0;k<2;k++) CORR[k][j] = corr[k][j]/var[k];
      CCORRP[j] = ccorrp[j]/sxy;  CCORRM[j] = ccorrm[j]/sxy;
   }
}
/************** correlation() end ***************************************/

/************** powerspectrum() *****************************************/
//ECORRW[0,1][i], CCORRW[i](i=0`n2) : window֊֐
//EO͂̎g : H(jz)=1(FmCY) =/(z+j)(LPFmCY)
//En̓`B֐ : G(jz)=1/{(z^2-1)+(2jz)}
//EvZ(1) PSD[0,1][] : ÓEp[XyNg Pxx, Pyy
//          (2) CPSD[] : ݃XyNg Pxy
//          (3) G1[], G2[], G3[] : `B֐=(Pyy/Pxx), Pxy/Pxx, Pyy/Pxy
//          (4) COH[] : Rq[V=Pxy/(Pxx*Pyy)
//(1) PSD[0][i] : Pxx=Fourier(CORRW[0]) : O͂̃p[XyNg(m/(rad/s))
//      FmCŶƂ͗_l Pxx=N^2=/*x^2
//      LPFmCŶƂ͗_l Pxx=N^2*|H(jz)|^2,
//    PSD[1][i] : Pyy=Fourier(CORRW[1]) : ̃p[XyNg(m/(rad/s))
//      FmCŶƂ͗_l Pyy=N^2*|G(jz)|^2
//      LPFmCŶƂ͗_l  Pyy=N^2*|H(jz)|^2*|G(jz)|^2
//(2) CPSD[i]   : Pxy=Fourier(CCORRW)  : ÓEԂ̑݃XyNg(m/(rad/s))
//      FmCŶƂ͗_l Pxy=N^2*G(jz)
//      LPFmCŶƂ͗_l  Pyy=N^2*H(jz)*G(jz)
//(3) G1,2,3[i] : G1[]=(Pyy/Pxx), G2[]=Pxy/Pxx, G3[]=Pyy/Pxy
//(4) COH[i]    : 
//EcoeddG[0,1] : 
/*************************************************************************/
void powerspectrum()
{
	int     i, j, k;

   //------- , ()(-)֐܂ԂCWindow ---------------------//
   if(window=='d')  for(j=0;j<=n1;j++)
   {    for(k=0;k<2;k++)  CORRW[k][n1-j] = CORRW[k][n1+j] = corr[k][j];
        CCORRW[j]    = ccorrm[n1-j];
		CCORRW[n1+j] = ccorrp[j];
   }
   if(window=='b')  for(j=0;j<=n1;j++)
   {    for(k=0;k<2;k++)  CORRW[k][n1+j] = CORRW[k][n1-j] = (n1-j)*corr[k][j]/n1;
        CCORRW[n1-j] = (n1-j)*ccorrm[j]/n1;
        CCORRW[n1+j] = (n1-j)*ccorrp[j]/n1;
   }

   //------------------- O͂̃p[XyNgx --------------------------//
   FourierT(CORRW[0], DT, n2, mp, Pc[0], Ps[0]);
   for(i=0;i<=mp;i++)	PSD[0][i] = sqrt(Pc[0][i]*Pc[0][i] + Ps[0][i]*Ps[0][i]);
   //------------------- ̃p[XyNgx --------------------------//
   FourierT(CORRW[1], DT, n2, mp, Pc[1], Ps[1]);
   for(i=0;i<=mp;i++)	PSD[1][i] = sqrt(Pc[1][i]*Pc[1][i] + Ps[1][i]*Ps[1][i]);

/*
if(sgnf=='w') printf("\n=%6.2f  nav=%3d",zeta,nav);
if(sgnf=='l') printf("\n=%6.2f  =%6.2f nav=%3d",zeta,tau,nav);
printf("\no͕U x^2=%7.4f=1̔Cy^2=%7.4f=0/(4)=%7.4f̔",var[0],var[1],1/(4*zeta));
nnoise = PAI/OMMAX;
if(sgnf=='w')
printf("\nFmCYXyNgx PSD[0][0]=%7.4f=N^2=/=%7.4f̔",PSD[0][m0],nnoise);
if(sgnf=='l'){
printf("\nLPFmCYXyNgx PSD[0][0]=%7.4f=N^2=/=%7.4f̔",PSD[0][0],nnoise);
printf("\ninvF(LPF)(0)=1/(2)=%7.4f  invF(G)(0)=thvar[1]=%7.4f",thvar[0],thvar[1]);} 
*/
   //------- ݃XyNgx ------------------------------------//
   FourierT(CCORRW, DT, n2, mp, CPc, CPs);
   for(i=0;i<=mp;i++)  	CPSD[i] = sqrt(CPc[i]*CPc[i] + CPs[i]*CPs[i]);
/*
printf("\nCPSD[]=(CPs, CPc)");
i=0;while(i<=100)
{ printf("\n%3d(%7.3f %7.3f) (%7.3f %7.3f) (%7.3f %7.3f) (%7.3f %7.3f)"
	,i,CPs[i],CPc[i],CPs[i+1],CPc[i+1],CPs[i+2],CPc[i+2],CPs[i+3],CPc[i+3]);
  i=i+4;}
*/
   //------- p[XyNg`B֐ --------------------------//
   for(i=0;i<=mp;i++)  	G1[i] = sqrt(PSD[1][i]/PSD[0][i]);
   //------- ݃XyNg`B֐(1) --------------------------//
   for(i=0;i<=mp;i++)
   {  G3[i] = CPSD[i]/PSD[0][i];
//   	  PH3[i] = -(atan2(CPs[i], CPc[i]) - atan2(Ps[0][i], Pc[0][i]) );
      //-------- ʑx𐳂Ƃ -----//
   	  PH3[i] = -atan2(CPs[i], CPc[i]);
//      if(PH3[i]> PAI) PH3[i] = PH3[i] - PAI;
//      if(PH3[i]> PAI) PH3[i] = PH3[i] - PAI;
//      if(PH3[i]< 0) PH3[i] = PH3[i] + PAI;
      if(PH3[i]< 0) PH3[i] = PH3[i] + PAI;
   }
   //------- ݃XyNg`B֐(2) --------------------------//
   for(i=0;i<=mp;i++)
   {  G4[i]  = PSD[1][i]/CPSD[i];
      //-------- ʑx𐳂Ƃ ------//
   	  PH4[i] = -( atan2(Ps[1][i], Pc[1][i]) - atan2(CPs[i], CPc[i]) );
      if(PH4[i]> PAI) PH4[i] = PH4[i] - PAI;
      if(PH4[i]> PAI) PH4[i] = PH4[i] - PAI;
      if(PH4[i]< 0) PH4[i] = PH4[i] + PAI;
      if(PH4[i]< 0) PH4[i] = PH4[i] + PAI;
   }
   //------- Rq[V ------------------------------------------//
   for(i=0;i<=mp;i++)  	COH[i] = CPSD[i]/sqrt(PSD[0][i]*PSD[1][i]);
}

/************ amppower() *****************************************************/
//   UXyNg |X(j)|^2, |Y(j)|^2̎ԕόvZ
/*****************************************************************************/
void amppower( void )
{
	int    i;
	double Ar;

  //-------- (2) XyNg̕ -----------------------------//
      //------- O͐UXyNgnav̕ ----------//
      FourierT(Bseries[0], DT, n2, mp, Fc, Fs);
       for(i=0;i<=mp;i++)
	   {  	Ar = (Fc[i]*Fc[i] + Fs[i]*Fs[i])/(2*Tn);
   	        APSD[0][i] = (nav*APSD[0][i] + Ar)/(nav+1);
	   }
      //------- UyNgnav̕ ----------//
      FourierT(Bseries[1], DT, n2, mp, Fc, Fs);
       for(i=0;i<=mp;i++)
	   {   if(sgnf=='w') Ar = (Fc[i]*Fc[i] + Fs[i]*Fs[i])/(2*Tn);
	       if(sgnf=='l') { Ar = (Fc[i]*Fc[i] + Fs[i]*Fs[i])/(2*Tn);
    	 	               Ar = Ar*(OMMAX/PAI)/(PAI/2);             }
		   APSD[1][i] = (nav*APSD[1][i] + Ar)/(nav+1);
	   }
	   //------- ÓE䂩`B֐vZ -----------------//
       for(i=0;i<=mp;i++)  G2[i] = sqrt(APSD[1][i]/APSD[0][i]);
}
/************ amppower() end ******************************************************/

/********* corrandspectrum() **********************************************/
void corrandspectrum( void )
{
	data(yy0);
	correlation();
	powerspectrum();
	amppower();
}

/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
int main(int argc, char *argv[])
{
	KEY = 'm';
	readrandom();      //\߈lzKzϊ\ǂݍ
	dialogue();

	DrawGL(&argc, argv);
}
/********* main() end ***********************************************************/

/*************** dialogue() *****************************************************/
void dialogue(void)
{
	static int i, j, k;

	if(KEY=='m')  goto d0;      //n̐ݒ肩蒼
	if(KEY=='f')  goto d2;      //O͐ݒ

//------------- ŏ蒼 ------------------------------------//
d0:
	printf("\nPRxUñ_O͂ɑ΂鉞̓vI");
	printf("\n(1) ̎ȑ֊֐ƃp[XyNg` ܂");
	printf("\n(2) ̑ݑ֊֐Ƒ݃XyNg` ܂");
	printf("\n(3) ^O͔䁁`B֐ƃRq[V`");
	printf("\n");
	printf("\nL[͂ɂύX");
	printf("\n'm'     Unp[^()ύX");
	printf("\n'f'     O͂̎ޑI");
	printf("\n'g' 'G' `B֐ or O̓XyNg`̑I");
	printf("\n'n'     f[^VɎ擾");
	printf("\n'w'     ֊֐ɂEBh[");
	printf("\n't' 'T' ԎLk");
	printf("\n'y' 'Y' XyNgcLk");
	//------------ Uñp[^ ------------------------//
	printf("\n");
d1:	printf("\n(1) PRxUniKj̃p[^ݒ(ŗLU0=1rad/s)");
	printf("\n     ddy/ddt + 2dy/dt + y = x(t) (noise)");
	printf("\n     ́@=");
	if(zeta<0) { printf("\n<0@蒼"); goto d1; }
	scanf("%lf", &zeta);   zeta2 = 2*zeta;
	//------------ O͂̑I --------------------------------------//
	printf("\n");
d2:	printf("\n(2) O͂̑I@FKEXG : w,  PxG : l    ");
	sgnf = getch();
	if(sgnf!='w' && sgnf!='l') { printf("\n'w'ł'l'łȂ. 蒼"); goto d2; }
	if(sgnf=='l')
	{	printf("\nPxnO X(j)=1/(1+jу),(0=1rad/s)   s=");  scanf("%lf",&tau); }
	printf("\n");
d3:	printf("\n(3) EBh[ޑI@Do-Nothing window : d,  Bartlet window : b    ");
	window = getch();
	if(window!='d' && sgnf!='b') { printf("\n'd'ł'b'łȂ. 蒼"); goto d3; }

	//---------------------  vZ菇@----------------------------------------//
	//@ (1) _ÓẼf[^n1ƂC֊֐XV
    //   (2) XyNgXVC`
	//   (3) (1)-(2)nnsJԂ
	//   (4) nnsȍ~(1)10sC(2)s
	//   (5) (4)ĨL[͂܂ŌJԂ
	//-------------------------------------------------------------------------//
	//----- ̑֊֐EXyNgvZ邽߂̏ --------------------//
	//      UU=1(rad/s), XyNgUd=0/m0(rad/s)
    //      m0Ԗ=1/d=1.0U_) 
	//      f[^̎荞ݐn1=5*m0, őU̐mp=4*m0
	//      őUp=mp*d(rad/s), ͉\ȍőU=n1*d(rad/s)
	//      f[^荞ݎԍdt=/(s)
	//      f[^̎荞ݎ=֊֐ő僉OTn=n=n1*dt(s) 
	//-------------------------------------------------------------------------//
	om0 = 1;                       //ňŗLU0=1rad/s
	m0  = 50;  dom = om0/m0;       //XyNgvZ̐U̍ݕ=0.02rad/s
	mp = 4*m0;  omp = mp*dom;      //XyNgEvZőU=4rad/s
	n1 = 5*m0;   n2 = 2*n1;        //֊֐ő僉O=250
    OMMAX = n1*dom;                //vZ\ȍőU=5rad/s
	DT = PAI/OMMAX;                //f[^擾̎ԍ=/=0.628s
	thnnoise = PAI/OMMAX;           //_IȐKFmCỸXyNgx=/
	nrkg = 4;  dt = DT/nrkg;       //RKGlvZ̎ԕ=0.157s
	Tn = n1*DT;                    //֊֐ő僉Oԃn=157.1s
	//---------------- I ---------------------------------------------//

	//------- _Iȉ̎ȑ֊֐E`B֐ --------------//
	thcorrelation(DT, n1, THCORR);
    thspectrum(dom, mp, THPSD, THG, THPH);

    //----- UvZFԂɂȂ܂ő҂ --------//
	yy0[0] = yy0[1] = yy0[2] = 0;
    for(i=0;i<=10;i++)  data(yy0);   //̐UvZ̏lyy0[]ɓĂ

	//---------  -------------------------------------------//
    nav = nn = 0;           //n1f[^̎荞݉񐔁ESf[^
	for(i=0;i<=n1;i++) Bseries[0][n1+i] = Bseries[1][n1+i] = 0;
	for(i=0;i<=n1;i++) corr[0][i] = corr[1][i] = 0;
	for(i=0;i<=n1;i++) ccorrp[i]  = ccorrm[i]  = 0;
	for(i=0;i<=n1;i++) APSD[0][i] = APSD[1][i] = 0;
	//------------------------------------------------------------//
	//--------- vZ ------------------------------------------//
	// f[^n1ƂCÕf[^ƕđ֌vZ                  //
	//   (1) corr[0][j]=corr[0][j]+x[i]x[i+j] (i,j=0`n1)        //
	//       corr[1][j]=corr[1][j]+y[i]y[i+j] (i,j=0`n1)        //
	//       ccorrp[j]=ccorrp[j]+x[i]y[i+j] (i,j=0`n1)          //
	//       ccorrm[j]=ccorrm[j]+y[i]x[i+j] (i,j=0`n1)          //
	//   (2) corr[0,1][j]̐KCORR[0,1][j]                    //
	//       ccorrp,m[j]̐KCCORRP,M[j]                      //
	//   (3) corr[0,1][j]window遨CORRW[0,1][j]             //
	//       ccorrp,m[j]window遨CCORRW[j]                  //
	//   (4) PSD[0,1][k]=Fourier(CORRW[0,1][j])                    //
	//       CPSD[k]=Fourier(CCORRW[j][])                          //
	//   (5) Ar[k]=Fourier(y[])^2  APSD[k]=APSD[k],Ar[k]̕   //
	//-------------------------------------------------------------//
    corrandspectrum();
	nav = 1;       //1ڂ̌vZI


	//---- e`̂߂̌_E݁E{ݒ  ----------------------//
	r0[0] = 0.01;    r0[1] = 0;     //`撆SD班炷
	//---- (1) ֊֐EUȐ`̂߂̐ݒ ---------------------//
	ra[0] = r0[0]-0.5; ra[1] = 0.4; //֊֐}̌_
	re[0] = r0[0]-0.5; re[1] = 0.2; //ݑ֊֐}̌_
	rb[0] = r0[0]-0.5; rb[1] = 0.0; //O͑֊֐}̌_
	rc[0] = r0[0]-1;   rc[1] =-0.5; //UȐ}̌_
	rd[0] = r0[0]-1;   rd[1] =-0.7; //O͐U}̌_
	wt = 0.01;                      //UE֊֐`̎ԍ݂̕
	nt = 0.5/wt;                    //UE֊֐`̍ݐ(nt*wt=0.5ƂȂ鐔)
	wa = wb = 0.5;                  //EO͎ȑ֊֐̏c{(1=5grid)
	wc = wd = 0.1;                  //EO͐Ȕc{(1=1grid)

	//------ (2) XyNg`̂߂̐ݒ@-------------------------------------//
    rp[0] = r0[0];  rp[1] = r0[1]+0.2;  //XyNgE`B֐G1̌_
    rq[0] = r0[0];  rq[1] = r0[1];      //UXyNgE`B֐G2̌_
    rs[0] = r0[0];  rs[1] = r0[1]-0.2;  //݃XyNǧ_
    rw[0] = r0[0];  rw[1] = r0[1]-0.5;  //O̓XyNǧ_
    ru[0] = r0[0];  ru[1] = r0[1]-0.7;  //O͐UXyNǧ_
    rt[0] = r0[0];  rt[1] = r0[1]-0.4;  //`B֐G4}̌_
    rv[0] = r0[0];  rv[1] = r0[1]-0.5;  //Rq[VCOH}̌_
    wom = 0.01;                         //XyNg}(0=5grid)
	wsp = 0.5;                          //p[XyNgEUXyNgc{
	wsw = 0.2;                          //O̓p[XyNgEUXyNgc{
	//---------------- `̂߂̐ݒI ------------------------------------//

	printf("\n\nʏ̕`U");
	if(sgng!='g')
	{
	printf("\nԁF@̎ȑ֊֐Cyy@@  EԁF@XyNgPyy");
	printf("\nF@O͂̎ȑ֊֐Cxx    @E㍕F@UXyNg|Y|^2");
	printf("\n㓍F@ݑ֊֐Cxy@@@@@@E㓍F@݃XyNgPxy");
	printf("\nԁF@̎g`y(t) @@@@@EF@O̓XyNgPxx");
	printf("\nF@O͂̎g`x(t) @@@@@EF@O͐UXyNg|X|^2");
	}
	if(sgng=='g')
	{
	printf("\nԁF@`B֐|G3|=|Pxy/Pxx|@EԁF@`B֐|G1|=(Pyy/Pxx)");
	printf("\n㍕F@`B֐|G4|=|Pyy/Pxy|  E㍕F@`B֐|G2|=|Y/X|");
	printf("\nԁF@ʑG3@          EF@Rq[VCo=|Pxy/(Pxx*Pyy)|");
	}
	printf("\n\n");
	printf("\n\nL['n'P񖈂ɕςCXyNg艻lq");

	printf("\n'm'L[       Fñp[^iājύX");
	printf("\n'f'L[       FÓiF or PxmCYjύX");
	printf("\n'd' or 'b'L[ŁFEBh[ύX");
	printf("\n'n'L[       FXƃf[^ƂCς");
	printf("\n'g' or 'p'L[ŁF`B֐ or O̓XyNg`ύX");
	printf("\n't' or 'T'L[ŁF֊֐Ef[^̎ԎkEg");
	printf("\n'y' or 'Y'L[ŁFXyNgc{kEg");
	printf("\n'z' or 'Z'L[ŁFXyNg{kEg");
	printf("\nESCL[ŁFI\n");

	printf("\nJԂ nav=%d,  擾f[^ nn=nav*n1=%d",nav,nav*n1);
}
/************ dialogue() end ***********************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("1DOF_U@m:āCf:ÓCd,b:window, g,p:G,P`CeύX, n:ς̌JԂ");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	if(sgng!='g')
	{
	//============= ֊֐Cxx,Cyy,Cxy` ====================================//
	r1[0] = rb[0]-0.5;  r1[1] = rb[1];
    usrGrating( r1, 0.0, 10, 0.1, 0.1 );   //Ԋ֐}̂߂grating
	//------------------- ֊֐`̐ -------------------------------//
	drawcharacter(-0.95, 0.90,  H18, "red   : response autocorrelation Cyy");
	drawcharacter(-0.95, 0.85,  H18, "pink  : crosscorrelation Cxy");
	drawcharacter(-0.95, 0.80,  H18, "blue  : force autocorrelation Cxx");
	drawcharacter(-0.95, 0.75,  H18, "green : theoretical Cyy,Cxx");
	//------------------- ̎ȑ֊֐Cyy` ------------------------//
	drawcurve1( ra,  wt, wa, nt, CORR[1], red );        //ȑ֊֐{
	drawcurve1( ra, -wt, wa, nt, CORR[1], red );        //ȑ֊֐|
	drawcurve1( ra,  wt, wa, nt, THCORR[1], green );    //_Iȑ֊֐{
	drawcurve1( ra, -wt, wa, nt, THCORR[1], green );    //_Iȑ֊֐|
	r1[0] = ra[0]-0.5;  r1[1] = ra[1];
	r2[0] = ra[0]+0.5;  r2[1] = ra[1];
    usrDrawLine2d(r1, r2, red);                         //ȑ֊֐X
	//------------------- ݑ֊֐`Cxy ------------------------------//
	drawcurve1( re,  wt, wa, nt, CCORRP, pink );       //ݑ֊֐{
	drawcurve1( re, -wt, wa, nt, CCORRM, pink );       //ݑ֊֐|
	r1[0] = re[0]-0.5;  r1[1] = re[1];
	r2[0] = re[0]+0.5;  r2[1] = re[1];
    usrDrawLine2d(r1, r2, black);                       //ݑ֊֐X
	//------------------- O͂̎ȑ֊֐`Cxx ------------------------//
	drawcurve1( rb,  wt, wb, nt, CORR[0], blue );       //O͎ȑ֊֐
	drawcurve1( rb, -wt, wb, nt, CORR[0], blue );       //O͎ȑ֊֐
	drawcurve1( rb,  wt, wb, nt, THCORR[0], green );    //O͗_Iȑ֊֐
	drawcurve1( rb, -wt, wb, nt, THCORR[0], green );    //O͗_Iȑ֊֐
	r1[0] = rb[0]-0.5;  r1[1] = rb[1];
	r2[0] = rb[0]+0.5;  r2[1] = rb[1];
    usrDrawLine2d(r1, r2, blue);                        //O͎ȑ֊֐X
	r2[0] = rb[0];  r2[1] = rb[1]+2.0;
    usrDrawLine2d(rb, r2, black);                       //ȁEݑ֊֐Y

	//========== ÓE̐U` =========================================//
	drawcharacter(-0.95, -0.20,  H18, "red   : response vibration y(t)");
	drawcharacter(-0.95, -0.25,  H18, "blue  : external force     x(t)");
	drawcurve1( rc, wt, wc, 2*nt, Aseries[1], red );    //UȐ
	r2[0] = rc[0]+1.0;  r2[1] = rc[1];
    usrDrawLine2d(rc, r2, red);                         //UȐX
	drawcurve1( rd, wt, wd, 2*nt, Aseries[0], blue );   //O͋Ȑ
	r2[0] = rd[0]+1.0;  r2[1] = rd[1];
    usrDrawLine2d(rd, r2, blue);                        //O͋ȐX
	//=========== XyNg` ==============================================//
	//-------------- XyNg`̐ ----------------------------------//
	drawcharacter(0.02, 0.90,  H18, "red    : response power spectrum Pyy");
	drawcharacter(0.02, 0.85,  H18, "black : response amplitude spectrum |Y|^2");
	drawcharacter(0.02, 0.80,  H18, "pink  : cross power spectrum |Pxy|");
	drawcharacter(0.02, 0.75,  H18, "green : theroetical spectrum Pyy, |Pxy|");
	drawcharacter(0.02, -0.25,  H18, "blue  : force power spectrum Pxx");
	drawcharacter(0.02, -0.30,  H18, "black : force amplitude spectrum |X|^2");
	drawcharacter(0.02, -0.35,  H18, "green : theoretical force spectrum Pxx");
	r1[0] = rp[0];   r1[1] = rp[1]-2.0;
	r2[0] = rp[0];   r2[1] = rp[1]+2.0;
    usrDrawLine2d(r1, r2, red);                     // eXyNgY
	r1[0] = r0[0]+m0*wom;   r1[1] = ru[1];
	r2[0] = r1[0];          r2[1] = r0[1] + 2.0;
    usrDrawLine2d(r1, r2, green);                   // Ugc
	//--------------- XyNg` -----------------//
	r2[0] = rp[0]+1.0;   r2[1] = rp[1];
    usrDrawLine2d(rp, r2, red);                     // XyNgX
	drawcurve1(rp, wom, wsp, mp, PSD[1], red);	    // XyNg}Pyy=|G|^2*Pxx
	drawcurve1(rp, wom, wsp, mp, THPSD[1], green);  // _IXyNg}
	r2[0] = rq[0]+1.0;   r2[1] = rq[1];
    usrDrawLine2d(rq, r2, black);                   // UXyNgX
	drawcurve1(rq, wom, wsp, mp, APSD[1], black);   // f[^̐UXyNgϐ}
	drawcurve1(rq, wom, wsp, mp, THPSD[1], green);  // _IXyNg}
	r2[0] = rs[0]+1.0;   r2[1] = rs[1];
    usrDrawLine2d(rs, r2, pink);                    // UXyNgX
	drawcurve1(rs, wom, wsp, mp, CPSD, pink);       // ݃XyNg}Pxy=|G|*Pxx
	drawcurve1(rs, wom, wsp, mp, THPSD[2], green);  // _IXyNg}
    //--------------- O̓XyNg` ----------------//
	drawcurve1(rw, wom, wsw, mp, PSD[0], blue);     // _O̓XyNg}Pxx
	drawcurve1(rw, wom, wsw, mp, THPSD[0], green);  // _I_O̓XyNg}
	r2[0] = rw[0]+2.0;   r2[1] = rw[1];
    usrDrawLine2d(rw, r2, blue);                    // O̓XyNgX
	drawcurve1(ru, wom, wsw, mp, APSD[0], black);   // O͐f[^̐UXyNgϐ}
	drawcurve1(ru, wom, wsw, mp, THPSD[0], green);  // _I_O̓XyNg}
	r2[0] = ru[0]+2.0;       r2[1] = ru[1];
    usrDrawLine2d(ru, r2, black);                   // O͕σXyNgX
	}
	if(sgng=='g')
	{
    //============= p[XyNg狁߂`B֐` ===========================//
	drawcharacter(0.02, 0.90,  H18, "red    : transfer function G1=sqrt(Pyy/Pxx)");
	drawcharacter(0.02, 0.85,  H18, "black : transfer function G2=sqrt(|Y/X|^2)");
	drawcharacter(0.02, 0.80,  H18, "green : theroetical transfer function thG");
	drawcharacter(0.02,-0.25,  H18, "pink  : coherency");
	r2[0] = rq[0];          r2[1] = rq[1] + 2.0;
    usrDrawLine2d(rq, r2, black);                   // `B֐}Y
	r1[0] = rq[0]+m0*wom;   r1[1] = rq[1];
	r2[0] = r1[0];          r2[1] = r1[1] + 2.0;
    usrDrawLine2d(r1, r2, green);                   // Ugc
	drawcurve1(rp, wom, wsp, mp, G1, red);          // XyNgx狁߂`B֐G1
	drawcurve1(rp, wom, wsp, mp, THG, green);       // _I`B֐}
	r2[0] = rp[0]+2.0;   r2[1] = rp[1];
    usrDrawLine2d(rp, r2, red);                     // `B֐G1X
	drawcurve1(rq, wom, wsp, mp, G2, black);        // UXyNg狁߂`B֐}G2
	drawcurve1(rq, wom, wsp, mp, THG, green);       // _I`B֐}
	r2[0] = rq[0]+2.0;       r2[1] = rq[1];
    usrDrawLine2d(rq, r2, black);                   // `B֐G2X
	//============ coherency` ============================================//
	drawcurve1(rv, wom, wsw, mp, COH, pink);        // coherency}
	r1[0] = rv[0];           r1[1] = rv[1] + wsw;
	r2[0] = rv[0]+2.0;       r2[1] = rv[1] + wsw;
    usrDrawLine2d(r1, r2, green);                   // coherency=1(_l)
	r2[0] = rv[0]+2.0;       r2[1] = rv[1];
    usrDrawLine2d(rv, r2, black);                   // coherencyX
	r2[0] = rv[0];           r2[1] = rv[1] + wsw;
    usrDrawLine2d(rv, r2, black);                   // coherencyY
    //============= ݃XyNg狁߂`B֐` ===========================//
	drawcharacter(-0.95, 0.95,  H18, "red   : transfer function G3=Pxy/Pxx");
	drawcharacter(-0.95, 0.90,  H18, "black: transfer function G4=Pyy/Pxy");
	mq = 1.0/wom;
	r1[0] = r0[0]-1.0;       r1[1] = r0[1]+0.2;
	drawcurve1(r1, wom, wsp, mq, G3, red);          // ݃XyNg狁߂`B֐}G3
	drawcurve1(r1, wom, wsp, mq, THG, green);       // _I`B֐}
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, red);                     // `B֐G3X
	r1[1] = r1[1]-0.2;
	drawcurve1(r1, wom, wsp, mq, G4, black);        // ݃XyNg狁߂`B֐}G4
	drawcurve1(r1, wom, wsp, mq, THG, green);       // _I`B֐}
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, black);                   // `B֐G4X
	r2[0] = r1[0];           r2[1] = r1[1]+2.0;
    usrDrawLine2d(r1, r2, black);                   // `B֐G3,4Y

	drawcharacter(-0.95, -0.40,  H18, "red  : phase shift arg(G3)");
//	drawcharacter(-0.95, -0.45,  H18, "black: phase shift arg(G4)");
	r1[0] = r0[0]-1.0;       r1[1] = r0[1]-0.1;
	drawcurve1(r1, wom, -0.4/PAI, mq, PH3, red);    // ݃XyNg狁߂`B֐ʑG3
	drawcurve1(r1, wom, -0.4/PAI, mq, THPH, green); // _I`B֐ʑ}G3
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, green);                     // `B֐ʑG3X
	r1[0] = r0[0]-1.0;       r1[1] = r0[1]-0.3;
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, green);                     // `B֐ʑG3=90̉
	r1[0] = r0[0]-1.0;       r1[1] = r0[1]-0.5;
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, green);                     // `B֐ʑG3=180̉EG4X
/*
	drawcurve1(r1, wom, -0.4/PAI, mq, PH4, black);    // ݃XyNg狁߂`B֐ʑG4
	drawcurve1(r1, wom, -0.4/PAI, mq, THPH, green);   // _I`B֐ʑ}G
	r1[0] = r0[0]-1.0;       r1[1] = r0[1]-0.7;
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, green);                     // `B֐ʑG4=90̉
	r1[0] = r0[0]-1.0;       r1[1] = r0[1]-0.9;
	r2[0] = r1[0]+1.0;       r2[1] = r1[1];
    usrDrawLine2d(r1, r2, green);                     // `B֐ʑG4=180̉
*/
	r2[0] = r1[0];           r2[1] = r1[1]+0.8;
    usrDrawLine2d(r1, r2, green);                     // `B֐ʑG3,4Y
	r1[0] = r0[0]-1.0+m0*wom;r1[1] = r0[1]-0.8;
	r2[0] = r1[0];           r2[1] = r1[1]+2.0;
    usrDrawLine2d(r1, r2, green);                     // Ugc
	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/

/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	int   k;

	KEY = key;

	//-------- f[^荞݂ƑցEXyNgvZ ---------//
	if(key=='n')
	{
		MotionSign = 0;
		if(nav<10) { corrandspectrum();  nav++; }
		else
		{   for(k=0;k<10;k++) {  data(yy0);
		                         correlation();
								 amppower();
								 nav++;          }
		    powerspectrum();
		}
		nn = nav*n1;
		printf("\nJԂ nav=%3d,  擾f[^ nn=nav*n1=%5d",nav,nn);
		usrdisplay();
		goto end;
	}
	//---------- UE֊֐ԎLk --------//
	if(key=='g' || key=='p')
	{
		MotionSign = 0;
		sgng = key;
       	usrdisplay();
		goto end;
	}
	//---------- UE֊֐ԎLk --------//
	if(key=='t' || key=='T')
	{
		MotionSign = 0;
		if(key=='t')  wt = 0.9*wt;
		if(key=='T')  wt = wt/0.9;
		nt = (int)(0.5/wt);
       	usrdisplay();
		goto end;
	}
	//----------- XyNg̉{Lk ---------------//
	if(key=='z' || key=='Z')
	{
		MotionSign = 0;
		if(key=='z')  wom = 0.9*wom;
		if(key=='Z')  wom = wom/0.9;
       	usrdisplay();
		goto end;
	}
	//----------- XyNg̏c{Lk ---------------//
	if(key=='y' || key=='Y')
	{
		MotionSign = 0;
		if(key=='y') { wsp = 0.9*wsp;   wsw = 0.9*wsw;  }
		if(key=='Y') { wsp = wsp/0.9;   wsw = wsw/0.9;  }
       	usrdisplay();
		goto end;
	}
	//----------- window̑I ---------//
	if(key=='d' || key=='b')
	{
		MotionSign = 0;
		window = key;
		powerspectrum();
       	usrdisplay();
		goto end;
	}
	//----------- ñp[^ύXiĕύX) ----//
	if(key=='m' || key=='f')
	{
		MotionSign = 0; 	dialogue();
		goto end;
	}
	//------------ V~[VI -----------------//
	if(key=='\033')
	{
		printf("\nf[^荞݌JԂnav=%d",nav);
		printf("\nf[^荞ݑ=nav*n1=%d",nn);
		exit(0);
	}

end:;
}

void motion_function(void){ }
